exports.main = () => {
  let inputLines = input.split('\n').map(x => x.trim()).filter(x => x), inputFirstLine = inputLines[0].split(' ');
  let nodeCount = parseInt(inputFirstLine[0]);

  let edges = inputLines.slice(1).map(x => x.split(' ').map(x => parseInt(x) - 1));
  function newArray(n, fn) {
    let a = new Array(n);
    for (let i = 0; i < n; i++) a[i] = fn();
    return a;
  }
  let haveEdge = newArray(nodeCount, () => newArray(nodeCount, () => false));
  edges.forEach(e => haveEdge[e[0]][e[1]] = true);

  let outputLines = user_out.split('\n').map(x => x.trim()).filter(x => x), outputAns = parseInt(outputLines.splice(-1)[0]);
  let answerLines = answer.split('\n').map(x => x.trim()).filter(x => x), ans = parseInt(answerLines.splice(-1)[0]);
  if (outputAns !== ans) exit({ score: 0, message: `Wrong answer - expected ${ans} but got ${outputAns}` });

  if (outputLines.length !== answerLines.length) exit({ score: 0, message: `Presentation error - expected ${answerLines.length} paths but got ${outputLines.length}` });

  let visited = new Array(nodeCount);
  outputLines.map(x => x.split(' ').map(x => parseInt(x) - 1)).forEach(path => {
    for (let i = 0; i < path.length - 1; i++) {
      if (!haveEdge[path[i]][path[i + 1]]) exit({ score: 0, message: `Wrong answer - there's no edge from ${path[i] + 1} to ${path[i + 1] + 1}` });
    }

    path.forEach(x => {
      if (visited[x]) exit({ score: 0, message: `Wrong answer - arrived node ${x + 1} for more than one times` });
      visited[x] = true;
    });
  });

  exit({ score: 100 });
};

/*
let fs = require('fs');
global.input = fs.readFileSync('path10.in').toString(); // '3 15\n3 3 4\n2 1 2\n1 3\n1 3\n1 3\n1 3\n3 1 2 3\n2 2 3\n2 1 3\n1 2\n1 2\n2 1 2\n2 1 3\n2 1 2\n1 1\n3 1 2 3\n';
global.user_out = fs.readFileSync('path10.out').toString(); // '1: 1 6 8\n2: 7 9 10\n3: 2 3 4 5\n';
global.answer = fs.readFileSync('path10.out').toString(); // '1: 1 6 8\n2: 7 9 10\n3: 2 3 4 5\n';
function exit(o) { console.log(o), process.exit(); }
exports.main();
*/

function exit(obj) {
  process.stdout.write(String(obj.score));
  if (obj.message) process.stderr.write(String(obj.message));
  process.exit();
}

let fs = require('fs');
let input = fs.readFileSync('input').toString();
let user_out = fs.readFileSync('user_out').toString();
let answer = fs.readFileSync('answer').toString();
let code = fs.readFileSync('code').toString();
exports.main();
